(*	esercizio 4.10 pagina 79 del testo
	Algoritmi e Strutture Dati (Alan Bertossi)

	versione ricorsiva
*)
Program alberobinario;
Type	binalbero = ^bincella;
	nodo = binalbero;
	bincella = record
		valore : Integer;
		sinistro, destro, genitore : nodo
	End;

Var	albero : binalbero;
Var	tmp1, tmp2, tmp3, tmp4 : binalbero;

Procedure CreaBinAlbero(Var T: binalbero);
Begin
	T := nil
End;

Function BinAlberoVuoto(Var T:binalbero) : boolean;
Begin
	BinAlberoVuoto := (T = nil)
End;

Function BinRadice(Var T:binalbero) : nodo;
Begin
	BinRadice := T
End;

Function BinPadre(u: nodo; Var T:binalbero) : nodo;
Begin
	BinPadre := u^.genitore;
End;

Function FiglioSinistro(u: nodo; Var T:binalbero) : nodo;
Begin
	FiglioSinistro := u^.sinistro
End;

Function FiglioDestro(u: nodo; Var T:binalbero) : nodo;
Begin
	FiglioDestro := u^.destro
End;

Function SinistroVuoto(u: nodo; Var T:binalbero) : boolean;
Begin
	SinistroVuoto := (u^.sinistro = nil)
End;

Function DestroVuoto(u: nodo; Var T:binalbero) : boolean;
Begin
	DestroVuoto := (u^.destro = nil)
End;

(* verifica se un dato nodo  una foglia *)
Function Foglia(u:nodo; Var T:binalbero) : boolean;
Begin
	Foglia := SinistroVuoto(u, T) and DestroVuoto(u, T)
End;

(* concatena due alberi e restituisce in T l'albero risultante *)
Procedure CostrBinAlbero(Var T, U:binalbero; val:integer);
Var w : nodo;
Begin
	new(w);
	w^.sinistro := T;
	w^.destro := U;
	w^.genitore := nil;
	w^.valore := val;
	if T<>nil then T^.genitore:=w;
	if U<>nil then U^.genitore:=w;
	T := w
End;

(* visita anticipata di un albero binario *)
Procedure BinVisita(u:nodo; Var T:binalbero);
Begin
	write(u^.valore, ' ');
	if not SinistroVuoto(u, T) then BinVisita(FiglioSinistro(u, T), T);
	if not DestroVuoto(u, T) then BinVisita(FiglioDestro(u, T), T)
End;

(* allocazione di un nodo e inizializzazione *)
Procedure AllocaNodo(Var T:nodo; val : Integer);
Begin
	new(T);
	T^.valore := val;
	T^.sinistro := NIL;
	T^.destro := NIL;
	T^.genitore := NIL;
End;

(* visita ricorsiva dell'albero e aggiunta di un figlio sinistro
ad ogni foglia contenente la somma dei valori incontrati nel percorso
padre->foglia *)
Procedure AppendiSomma(somma: integer; u:nodo; Var T:binalbero);
Var tmp : binalbero;
Begin
	somma := somma + u^.valore;
	if not SinistroVuoto(u, T) then AppendiSomma(somma, FiglioSinistro(u, T), T);
	if not DestroVuoto(u, T) then AppendiSomma(somma, FiglioDestro(u, T), T);

	if Foglia(u, T) then 
	Begin
		AllocaNodo(tmp, somma);
		tmp^.genitore := u;
		u^.sinistro := tmp		
	End
End;

Begin
	(* creazione dei nodi foglia *)
	(* nodo 27 *)
	CreaBinAlbero(tmp1);
	AllocaNodo(tmp1, 27);
	(* nodo 31 *)
	CreaBinAlbero(tmp2);
	AllocaNodo(tmp2, 31);
	(* nodo 19 *)
	CreaBinAlbero(tmp3);
	AllocaNodo(tmp3, 19);

	CostrBinAlbero(tmp1, tmp2, 13);
	(* attenzione: cos' cambiato in tmp1 o tmp2? *)

	CreaBinAlbero(tmp4);
	CostrBinAlbero(tmp3, tmp4, 21);
	CostrBinAlbero(tmp1, tmp3, 9);

	albero := tmp1;

	BinVisita(albero, albero);

	writeln();
	AppendiSomma(0, albero, albero);
	writeln();

	BinVisita(albero, albero);
End.